//-+-------------------------------------------------------------------------+-
//    ball.cc: classes definition               
//-+-------------------------------------------------------------------------+-
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "def.h"
#include "net.h"
#include "world.h"

//-+---------- Ball Constructor ---------------------------------------------+-
Ball::Ball(int x, int z) {
   posX = x ;
   posY = BALL_POSY ;
   posZ = z ;
   angle = 0 ;
   power = 0 ;
}

//-+---------- Moving the Ball ------------------------------------------------+-
int Ball::Go() {
   
   posX = posX + 0.2*cos(angle) ;
   posZ = posZ + 0.2*sin(angle) ;
   return( 1) ;
}

//-+---------- R of a Ball -------------------------------------+-
void Ball::Rebondir(int bord, float effect, int rpower) {
   
   if ( rpower == -1 ) {
      if ( bord == CHORIZ )
	angle = 3.142 - angle ; 
      if ( bord == CVERT )
	angle = 6.284 - angle ; 
   }
   else { /* modify direction & power */
      angle = effect ;
      power = ( power + rpower ) / 2 ;
   }
   
   power = power / 1.01 ;
   if ( power > 15 )
     power = 15 ;
   if ( power < 4 )
     power = 4 ;
   /* not to have nul progress */
   if ( angle >  0.00 && angle <= 0.20 ) angle = +0.20 ;
   if ( angle > -0.20 && angle <= 0.00 ) angle = -0.20 ;
   Go() ;
}

//-+---------- Ball Destructor ----------------------------------------------+-
Ball::~Ball()
{
}
